#include "ArrayEx.au3"
#include <array.au3>

#Region ### Cration des fichiers d'exemple ###
Global $aFile[6] = ["Array_1.txt", "Array_2.txt", "Array_3.txt", "Array_4.txt", "Array.html"]
_Complex_Array_File(@ScriptDir & "\" & $aFile[0])
_Big_Array_File(@ScriptDir & "\" & $aFile[1])
_Simple_Array_File(@ScriptDir & "\" & $aFile[2])
_Medium_Array_File(@ScriptDir & "\" & $aFile[3])
_HTML_Array_File(@ScriptDir & "\" & $aFile[4])
; Test si tout les fichiers ont t crs.
For $i = 0 To UBound($aFile) - 1
	If Not FileExists(@ScriptDir & "\" & $aFile[$i]) Then _Error()
Next
#EndRegion ### Fin de cration des fichiers d'exemple ###

Global $aString, $File, $String

MsgBox(64, "Information", "Voici le fichier d'exemple Array_1.txt" & @CRLF & @CRLF & FileRead("Array_1.txt"))

; _StringToArray1D : Lit le fichier et cre un tableau 1D.
$File = FileRead("Array_1.txt")
$aString = _StringToArray1D($File)
_ArrayDisplay($aString, "Tableau 1D  partir d'un fichier/chane")

; StringToArray2D : Lit le fichier et cre un tableau 2D.
$File = FileRead("Array_1.txt")
$aString = _StringToArray2D($File, @CRLF, ",")
_ArrayDisplay($aString, "Tableau 2D  partir d'un fichier/chane")

; _StringToArray2D : Lit le fichier et cre un tableau 2D sans lignes blanche et sans index.
$File = FileRead("Array_1.txt")
$aString = _StringToArray2D($File, @CRLF, ",", 0, 0)
_ArrayDisplay($aString, "Tableau 2D  partir d'un fichier/chane sans index et ligne blanche")

; _StringToArray2D : Lit le fichier Array_2.txt de la ligne 1  20, colonne 10  20 et cre un nouveau tableau
$File = FileRead("Array_2.txt")
$aString = _StringToArray2D($File, @CRLF, ",", 1, 1, 1, 20, 10, 20)
_ArrayDisplay($aString, "Lignes 1  20 et colonnes 10 a 20 du fichier Array_2.txt")
; Notez que dans cet exemple, le tableau montre un effet perturbant pour certaines personnes.
; Je demande de lire le tableau de la ligne 1  20 et de la colonne 10  20.
; Le nouveau tableau est compos de 20 Lignes ([1]  [20]) mais de 11 Colonnes ([0]  [10]),
; simplement parce que pour les lignes je dmarre de 1 et pour les colonnes, je dmarre de 10.
; En dmarrant de 10, c'est comme si je dmarrais de 0. ;)

; _Array2DToString : Convertit le tableau prcdent en chane.
$String = _ArrayToStringEx($aString, "", ",", 1, 1)
MsgBox(64, "Information", "Tableau 2D convertit en chane" & @TAB & @CRLF & @CRLF & $String)

; _ArrayDeleteLines : Supprime les lignes vides d'un tableau 2D de 50X10 lments puis les lignes contenant la valeur 10 et 100.
$File = FileRead("Array_4.txt")
$aString = _StringToArray2D($File, @CRLF, ",", 1)
_ArrayDisplay($aString, "Tableau 50X10")
_ArrayDeleteLines($aString)
_ArrayDisplay($aString, "Lignes vide du tableau 50X10 supprimes")
_ArrayDeleteLines($aString, "10;100", 0)
_ArrayDisplay($aString, "Tableau 50X10 sans ligne contenant 10 et 100")

; _ArrayConcatenate2D Ajoute $aArray2 (2D)  $aArray1 (2D) :
Dim $aArray1[4][3]=[["a","b","1"],["c","d","2"],["e","f","3"],["g","h","4"]]
Dim $aArray2[3][5]=[["i","j","5","6","7"],["k","k","6","7","8"],["m","n","7","8","9"]]
_ArrayConcatenateEx($aArray1, $aArray2)
If @error Then MsgBox(0,"", "Erreur N" & @error)
_ArrayDisplay($aArray1, "$aArray1 + $aArray2")

; _ArrayConcatenateEx Ajoute $aArray3 (1D) au nouvel $aArray1 (2D) :
Dim $aArray3[4]=["a1","b1","c1","d1"]
_ArrayConcatenateEx($aArray1, $aArray3)
If @error Then MsgBox(0,"", "Erreur N" & @error)
_ArrayDisplay($aArray1, "New $aArray1 + $aArray3")

; _HtmlArrayToArray2D : Lit le deuxime tableau du fichier Array.html
$File = @ScriptDir & "\Array.html"
$Index = 1
MsgBox(64, "Information", "Pour l'exemple suivant, cliquez OK " & "et patientez 5  10 secondes")
$aArray = _HtmlArrayToArray2D($File, $Index)
_ArrayDisplay($aArray, "Deuxime tableau du fichier Array.html")

; _HtmlArrayToArray2D : Lit un tableau  partir d'une URL
$File = "http://www.autoitscript.com/trac/autoit/query?status=new"
$Index = 2
MsgBox(64, "Information", "Pour l'exemple suivant, cliquez OK " & "et patientez 5  10 secondes")
$aArray = _HtmlArrayToArray2D($File, $Index)
_ArrayDisplay($aArray, "Tableau  partir d'une URL")

; _Array2DToHtmlArray : Cre un tableau html  partir d'un tableau 2D
$File = @ScriptDir & "\Exemple.html"
$String = _Array2DToHtmlArray($aArray, 1, 0)
$html = "<html>" & @CRLF & $String & "</html>"
$hFile = FileOpen($File, 2)
FileWrite($hFile, $html)
FileClose($hFile)
ShellExecutewait($File)

MsgBox(64, "Exemples ArrayEx", "Fin de tous les exemples de l'utilisation de l'UDF ArrayEx." & @CRLF & "Les fichiers d'exemple vont tre supprims maintenant.")
FileDelete(@ScriptDir & "\*.txt")
FileDelete(@ScriptDir & "\*.html")
Exit


#Region ### Fonctions pour la cration des fichiers d'exemple ###
Func _Complex_Array_File($sFile)
	Global $i, $j, $Var
	Global $hFile = FileOpen($sFile, 2)
	If $hFile = -1 Then Return SetError(1, 0, 0)

	; Cre un tableau 10X10
	For $i = 1 To 10
		$Var = ""
		For $j = 1 To 10
			$Var &= Random(1, 100, 1) & ","
		Next
		FileWriteLine($hFile, StringTrimRight($Var, 1))
	Next
	FileWriteLine($hFile, "") ; Ajoute une ligne vierge
	; Ajoute un tableau 8X15
	For $i = 1 To 8
		$Var = ""
		For $j = 1 To 15
			$Var &= Random(1, 100, 1) & ","
		Next
		FileWriteLine($hFile, StringTrimRight($Var, 1))
	Next

	FileClose($hFile)
	Return 1
EndFunc   ;==>_Complex_Array_File

Func _Medium_Array_File($sFile)
	Global $i, $j, $Var
	Global $hFile = FileOpen($sFile, 2)
	If $hFile = -1 Then Return SetError(1, 0, 0)

	; Cre un tableau 50X10 avec des lignes vide
	For $i = 1 To 50
		$Var = ""
		If Random(1, 4, 1) = 1 Then
			FileWriteLine($hFile, "")
		Else
			For $j = 1 To 10
				$Var &= Random(1, 100, 1) & ","
			Next
			FileWriteLine($hFile, StringTrimRight($Var, 1))
		EndIf
	Next

	FileClose($hFile)
	Return 1
EndFunc   ;==>_Big_Array_File

Func _Big_Array_File($sFile)
	Global $i, $j, $Var
	Global $hFile = FileOpen($sFile, 2)
	If $hFile = -1 Then Return SetError(1, 0, 0)

	; Cre un tableau 1000X200 avec des lignes vide
	For $i = 1 To 1000
		$Var = ""
		For $j = 1 To 200
			$Var &= Random(1, 100, 1) & ","
		Next
		FileWriteLine($hFile, StringTrimRight($Var, 1))
	Next

	FileClose($hFile)
	Return 1
EndFunc   ;==>_Big_Array_File

Func _Simple_Array_File($sFile)
	Global $hFile = FileOpen($sFile, 2)
	If $hFile = -1 Then Return SetError(1, 0, 0)

	; Cre seulement une ligne de deux donnes
	FileWriteLine($hFile, Random(1, 100, 1) & "," & Random(1, 100, 1))

	FileClose($hFile)
	Return 1
EndFunc   ;==>_Simple_Array_File

Func _HTML_Array_File($sFile)
	Global $hFile = FileOpen($sFile, 2)
	If $hFile = -1 Then Return SetError(1, 0, 0)

	; Cre un fichier html contenant 2 tableaux
	$HtmlFile = '<HTML>'  & @CRLF & _
				'<TABLE frame="border" cellpadding="2">' & @CRLF & _
				'<TR>' & @CRLF & _
				'<TD> cell 1.1 </TD>' & @CRLF & _
				'   <TD> cell 1.2 </TD>' & @CRLF & _
				'  </TR>' & @CRLF & _
				'  <TR>' & @CRLF & _
				'   <TD> cell 2.1 </TD>' & @CRLF & _
				'   <TD> cell 2.2 </TD>' & @CRLF & _
				'  </TR>' & @CRLF & _
				' </TABLE>' & @CRLF & _
				'<br>' & @CRLF & _
				'<br>' & @CRLF & _
				' <TABLE frame="border" cellpadding="2">' & @CRLF & _
				'  <TR>' & @CRLF & _
				'   <TH align="center"> title 1</TH>' & @CRLF & _
				'   <TH align="center"> title 2 </TH>' & @CRLF & _
				'  </TR>' & @CRLF & _
				'  <TR>' & @CRLF & _
				'   <TD> text 1</TD>' & @CRLF & _
				'   <TD> text 2</TD>' & @CRLF & _
				'  </TR>' & @CRLF & _
				'</TABLE>' & @CRLF & _
				'</HTML>'
	FileWriteLine($hFile, $HtmlFile)

	FileClose($hFile)
	Return 1
EndFunc   ;==>_HTML_Array_File

Func _Error()
	MsgBox(16, "Erreur", "Erreur de cration des fichiers d'exemples. Sortie ...")
	Exit
EndFunc   ;==>_Error
#EndRegion ### Fin des Fonctions pour la cration des fichiers d'exemple ###
